
#include <stdlib.h>
#include <stdio.h>
#include "utils.h"
#include "iris_3_3.h"
#include "q_iris_3_3.h"

#ifndef EPS
#define EPS 0.03
#endif

#define FEATURES_SIZE 4
#define OUTPUT_SIZE 3

float nondet_float();
        
static const double x0[FEATURES_SIZE] =
{
	0.13888888888888884,
	0.41666666666666674,
	0.06779661016949151,
	0.08333333333333333
};

int main()
{
	double symbolic_x[FEATURES_SIZE];
	for(size_t i = 0; i < FEATURES_SIZE; i++)
	{
	    symbolic_x[i] = (double) nondet_float();
		__ESBMC_assume(x0[i] - EPS <= symbolic_x[i] && 
		    symbolic_x[i] <= x0[i] + EPS);
	}
	
	double y[3];
	iris_3_3((const double *) symbolic_x, (double *) y);
	int prediction = argmax((double *) y, OUTPUT_SIZE);

	double q_y[3];
	q_iris_3_3((const double *) symbolic_x, (double *) q_y);
	int q_prediction = argmax((double *) q_y, OUTPUT_SIZE);
 
    __ESBMC_assert(prediction == q_prediction, "Counter-Example");
}
